﻿/********************************************************************
  Copyright (c) 2025 此乃刘同学.www.liustu.com.cn
  FileName : insert.c
  Author   : 刘斌
  Version  : V1.0
  Date     : 2025-3-31
  Note     : C仿写sqlite3-嵌入式轻量级数据库
  History  : 2025-4-2 	V1.0 		完成初步编辑
********************************************************************/
#include "insert.h"

/**
  * @brief  创建索引
  * @param 	dbname: 数据库名,tablename: 表名,cmd: 用户输入命令
  * @retval 0:成功
  */
int Insert_Value(char *dbname, char *tablename, char *cmd){
    int start_len = (strlen(dbname) + 7);
    char value_cmd[100];
    fpos_t pos_start;
    fpos_t pos_end;
    int ch_count;
    int va_count;
    char line_str[256];
    int line_flag = 0;
    char *table_temp = (char *)malloc(sizeof(tablename) + 6) ;
    if(!table_temp) {
        printf("注意：内存分配失败\r\n");
    }
    sprintf(table_temp, "TABLE %s", tablename);
    // printf("%s\n",table_temp);

    /* 保存参数的字符串 */
    char *start = strchr(cmd, '(');
    char *end = strchr(cmd, ')');
    size_t  length = end - start;

    char *parameter_temp = (char *)malloc(sizeof(char) * length);
    if(!parameter_temp) {
        printf("注意：内存分配失败\r\n");
    }
    strncpy(parameter_temp, start + 1, length-1);
    // printf("%s", parameter_temp);

    /* 跳转到数据库存放的路径下 */
    chdir("sqlfile");

     /* 打开或创建数据库 */
    FILE *dbfile = fopen(dbname, "r+");

    /* 逐行读取 */
    while(fgets(line_str, sizeof(line_str), dbfile)){
        /* 当出现 tablename时,数据库中有相同的表 */
        if(strstr(line_str, tablename)) {
            // printf("出现相同表\n");
            line_flag = 1;
            // 保存当前位置
            fgetpos(dbfile, &pos_start);
            break;
        }
    }

    /* 如果没有这个表，则就无法插入数据 */
    if(line_flag == 0)
        goto BACK;
    
    /* 获取每个参数的内容 */
    ch_count = StrChrShow(parameter_temp, ',') + 1;
    char **parameter = (char **)malloc(ch_count * sizeof(char *));
    if(!parameter) {
        printf("注意：内存分配失败\r\n");
    }
    char *token = strtok(parameter_temp, ",");
    for (int x = 0; x < ch_count; x++) {
        /* 没有参数了 */
        if (token == NULL) {
            break; 
        }
        parameter[x] = (char *)malloc((strlen(token) + 1) * sizeof(char));
        if(!parameter[x]) {
            printf("注意：内存分配失败\r\n");
        }
        strcpy(parameter[x], token); 
        token = strtok(NULL, ","); 
    }

    /* 读取表中数据内容 */
    char *line_parameter[256]; 
    char *line_type[256]; 
    int i = 0; 

    while(fgets(line_str, sizeof(line_str), dbfile)){
        char *line_temp = (char *)malloc(strlen(line_str));
        if(!line_temp) {
            printf("注意：内存分配失败\r\n");
        }
        strcpy(line_temp, line_str);
        /* 去掉换行符 */
        line_str[strcspn(line_str, "\n")] = '\0';
        /* 读到END就结束了 */
        if(strcmp(line_str, "END") == 0){
            // 保存当前位置
            fgetpos(dbfile, &pos_end);
            break;
        }   

        char *token = strtok(line_str, " ");
        char *type = strtok(NULL, " ");
        if(token != NULL){
            line_parameter[i] = strdup(token);
            line_type[i] = strdup(type);
        }
        // printf("%s\t", line_parameter[i]);
        // printf("%s\n", line_type[i]);
        //  printf("%s \n",line_temp);
        /* 这个参数不能为空 */
        if(strstr(line_temp, "NOT NULL")){
            int y;
            for(y = 0;y < ch_count;y++){
                if(strcmp(parameter[y], line_parameter[i]) == 0)
                    break;
            }
            /* 不为空的参数没有被赋值 */
            if(y == ch_count){
                printf("存在不能为空的参数未赋值\n");
                goto BACK;
            }
        }
        i ++;
        free(line_temp);
    }

    
    /* 判断输入的参数，表中有 */
    if (ch_count > i) {
        printf("错误：添加了表中没有的元素\n");
        goto BACK;
    }

    /* 参数表中没有 */
    for (int y = 0; y < ch_count; y++) {
        int param_found = 0;  // 标记参数是否在表中找到
        for (int x = 0; x < i; x++) {
            trim(parameter[y]);
            trim(line_parameter[x]);
            if (strcmp(line_parameter[x], parameter[y]) == 0) {
                param_found = 1;  // 参数在表中找到
                break;
            }
        }
        if (!param_found) {
            printf("错误：参数 '%s' 不在表中\n", parameter[y]);
            goto BACK;
        }
    }

    /* 存放参数 */
    fsetpos(dbfile, &pos_end);
    while (1) {
        /* 读取命令 */
        int count = start_len;
        while (count--)
            printf(" ");
        printf("> ");
        fgets(value_cmd, sizeof(value_cmd), stdin);

        /* 去掉换行符 */
        value_cmd[strcspn(value_cmd, "\n")] = '\0';

        /* 提取括号内的内容 */
        start = strchr(value_cmd, '(');
        end = strchr(value_cmd, ')');
        if (start == NULL || end == NULL || start >= end) {
            continue; // 跳过本次循环
        }
        size_t length = end - start - 1; // 计算括号内的内容长度

        /* 重新分配内存 */
        char *parameter_temp = (char *)malloc(length + 1); // 分配足够的内存
        if(!parameter_temp) {
            printf("注意：内存分配失败\r\n");
        }
        strncpy(parameter_temp, start + 1, length);
        parameter_temp[length] = '\0'; // 添加字符串结束符

        /* 获取每个参数的内容 */
        va_count = StrChrShow(parameter_temp, ',') + 1;
        char **value = (char **)malloc(va_count * sizeof(char *));
        if(!value) {
            printf("注意：内存分配失败\r\n");
        }
        token = strtok(parameter_temp, ",");
        for (int x = 0; x < va_count; x++) {
            /* 没有参数了 */
            if (token == NULL) {
                break; 
            }
            value[x] = (char *)malloc((strlen(token) + 1) * sizeof(char));
            if(!value[x] ) {
                printf("注意：内存分配失败\r\n");
            }
            strcpy(value[x], token); 
            token = strtok(NULL, ","); 
        }

        /* 定位到表末尾的空行 */
        fpos_t empty_line_pos1;
        fpos_t empty_line_pos2;
        fgetpos(dbfile, &empty_line_pos2);
        while (fgets(line_str, sizeof(line_str), dbfile) != NULL) {
            empty_line_pos1 = empty_line_pos2;
            fgetpos(dbfile, &empty_line_pos2);
            if (strcmp(line_str, "\n") == 0) {
                // 检测到空行，保存当前位置
                break;
            }
        }

        /* 将文件指针移动到空行的起始位置 */
        fsetpos(dbfile, &empty_line_pos1);

        /* 插入数据并后移后续内容 */
        char buffer[1024];
        long insert_pos = ftell(dbfile);  // 保存插入位置
        FILE *temp_file = tmpfile();  // 创建临时文件
        if (temp_file == NULL) {
            printf("错误：无法创建临时文件\n");
            goto BACK;
        }

        // 将插入位置之后的内容写入临时文件
        while (fgets(buffer, sizeof(buffer), dbfile) != NULL) {
            fputs(buffer, temp_file);
        }

        // 将文件指针移回插入位置
        fseek(dbfile, insert_pos, SEEK_SET);

        /* 传入数据 */
        int save_flag;
        for (int x = 0; x < i; x++) {
            save_flag = 0;
            /* 对比数据内容 */
            for (int y = 0; y < va_count; y++) {
                /* 传入参数与接收的数据相同 */
                if (strcmp(line_parameter[x], parameter[y]) == 0) {
                    save_flag = 1;
                    /* 检查字段类型是否为字符串类型，如果是，添加引号 */
                    if (strcmp(line_type[x], "CHAR") == 0 || strcmp(line_type[x], "VARCHAR") == 0) {
                        fprintf(dbfile, "'%s' \\", value[y]);
                    } else {
                        fprintf(dbfile, "%s \\", value[y]);
                    }
                    break;
                }
            }
            /* 如果字段没有传入值，且字段不允许为空，则报错 */
            if (!save_flag) {
                if (strstr(line_str, "NOT NULL")) {
                    printf("错误：字段 '%s' 不允许为空\n", line_parameter[x]);
                    goto BACK;
                } else {
                    fprintf(dbfile, "NULL \\");
                }
            }
        }
        fprintf(dbfile, "\n");
        fprintf(dbfile, "\n");

        /* 将临时文件中的内容写回原文件 */
        rewind(temp_file);
        while (fgets(buffer, sizeof(buffer), temp_file) != NULL) {
            fputs(buffer, dbfile);
        }

        fclose(temp_file);

        /* 释放内存 */
        free(parameter_temp);
        for (int x = 0; x < va_count; x++) {
            // printf("%s\t", value[x] );
            free(value[x]); 
        }
        /* ;结束 */
        if (strchr(value_cmd, ';')){
            fprintf(dbfile, "\n");
            break;
        }
            
    }

    for (int x = 0; x < ch_count; x++) {
        free(parameter[x]);
    }
    for (int j = 0;j < i;j++){
        free(line_parameter[j]);
        free(line_type[j]);
    }
  
BACK:
    /* 关闭文件 */
    fclose(dbfile);
    dbfile = NULL;

    /* 释放空间 */
    free(parameter);
    free(parameter_temp);
    free(table_temp);
    return 0;
}

/**
  * @brief  字符串中字符出现的字数
  * @param 	strdata: 字符串: 表名,chdata: 查找的字符
  * @retval 字符出现次数
  */
int StrChrShow(char *strdata, char chdata){
    char *ponit = strdata;
    int count = 0;
    while(*ponit != '\0'){
        if(*ponit == chdata)
            count++;
        ponit++;
    }

    return count;
}
